/*
 * Created on 14-Jan-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package view;

import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import model.ColoredShape;
import model.DocObserver;
import model.Pixel;
import model.Shape;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ColorParameter extends JPanel implements DocObserver {
	private BufferedImage img;
	private int size = 40;
	private double red = 0;
	private double green = 0;
	private double blue = 0;
	
	ColorParameter() {
		add(new JLabel("Color:"));
		img = new BufferedImage(size, size, BufferedImage.TYPE_INT_RGB);
		computeImage();
		ImageIcon ii = new ImageIcon(img);
		JButton colorButton = new JButton(ii);
		colorButton.addActionListener(
			new AbstractAction() {
				public void actionPerformed(ActionEvent ae) {
					Application app = Application.getInstance();
					Pixel p = ColorDialog.getColor(app, red, green, blue, 150);
					app.colorSelectedObjects(p);
				};
			});
		add(colorButton);
	}
	
	private void computeImage() {
		Pixel p = new Pixel();
		// TODO EP need to add setRed... with double to Pixel.
		p.setRed((int)(red*255.0));
		p.setGreen((int)(green*255.0));
		p.setBlue((int)(blue*255.0));
		p.setAlpha(255);
		int rgb = p.getARGB();
		for (int i = 0; i<size; ++i) {
			for (int j = 0; j<size; ++j) {
				img.setRGB(i, j, rgb);
			}
		}
	}

	/* (non-Javadoc)
	 * @see Model.DocObserver#docChanged()
	 */
	public void docChanged() {
	}

	/* (non-Javadoc)
	 * @see Model.DocObserver#docSelectionChanged()
	 */
	public void docSelectionChanged() {
		List list = Application.getInstance().getActiveDocument().getSelectedObjects();
		// TODO EP If the list is empty, this widget should disapear
		// TODO EP If the list contains many objects, it is not clear which color to show.
		//      But the user should be able to modify the color and this color be affected to all the objects.
		if (list.iterator().hasNext()) {
			Object ColoredShape = null;
			Shape s = (Shape)list.iterator().next();
			if (s instanceof ColoredShape) {
				ColoredShape cs = (ColoredShape)s;
				Pixel pixel = cs.getColor();
				red = (double)pixel.getRed() / 255.0;
				green = (double)pixel.getGreen() / 255;
				blue = (double)pixel.getBlue() / 255;
				computeImage();
				repaint();
			}
		}
	}
}
